#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
PFNGLLOADTRANSPOSEMATRIXDPROC glLoadTransposeMatrixd;
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  define GL_GLEXT_PROTOTYPES
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 0.0, 0.0, 1.0, 0.0 }; /* ֡ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ľܸ */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* Ķ */

/*
** ƥ
*/
#define TEXWIDTH  1024                     /* ƥ */
#define TEXHEIGHT 128                      /* ƥι⤵ */
static const char texture1[] = "dice.raw"; /* ƥե̾ */
static GLuint texname[1];                  /* ƥֹ̾ */

/*
** 
*/
static void init(void)
{
  /* ƥɤ߹ߤ˻Ȥ */
  GLubyte texture[TEXHEIGHT * TEXWIDTH * 4];
  FILE *fp;
  
#if 0
  /* ƥɤ߹ */
  if ((fp = fopen(texture1, "rb")) != NULL) {
    fread(texture, sizeof texture, 1, fp);
    fclose(fp);
  }
  else {
    perror(texture1);
  }
#endif
  
  /* ƥ͡򣱸 */
  glGenTextures(1, texname);
  
  /* ƥϥñ̤˵ͤޤƤ */
  glPixelStorei(GL_UNPACK_ALIGNMENT, 4);
  
  /* ƥγ */
  glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, 0,
    GL_RGBA, GL_UNSIGNED_BYTE, texture);
  
  for (int i = 0; i < 6; ++i) {
    /* ƥե̾ */
    static const char *textures[] = {
      "room2ny.raw", /*  */
      "room2nz.raw", /* ΢ */
      "room2px.raw", /*  */
      "room2pz.raw", /*  */
      "room2nx.raw", /*  */
      "room2py.raw", /*  */
    };
    /* ƥΥå̾ */
    static const int target[] = {
      GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
      GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
      GL_TEXTURE_CUBE_MAP_POSITIVE_X,
      GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
      GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
      GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
    };
    
    if ((fp = fopen(textures[i], "rb")) != NULL) {
      /* ƥɤ߹ */
      fread(texture, 128 * 128 * 4, 1, fp);
      fclose(fp);
      /* ƥ֤ */
      glTexSubImage2D(GL_TEXTURE_2D, 0, i * 128, 0, 128, 128,
        GL_RGBA, GL_UNSIGNED_BYTE, texture);
      /* 塼֥ޥåԥ󥰤Υƥγ */
      glBindTexture(GL_TEXTURE_CUBE_MAP, texname[0]);
      glTexImage2D(target[i], 0, GL_RGBA, 128, 128, 0, 
        GL_RGBA, GL_UNSIGNED_BYTE, texture);
      glBindTexture(GL_TEXTURE_2D, 0);
    }
  }
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
#if 0
  /* ƥĶ */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
#endif
  
  /* оݤtexname[0] Υƥڤؤ */
  glBindTexture(GL_TEXTURE_CUBE_MAP, texname[0]);
  
  /* ƥ硦̾ˡλ */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* ƥη֤ˡλ */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP);
  
  /* 塼֥ޥåԥѤ˥ƥɸ */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  
  /* оݤ̵̾ƥ᤹ */
  glBindTexture(GL_TEXTURE_2D, 0);
  
  /*  */
  glClearColor(0.3, 0.3, 1.0, 0.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ν */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
  
#if defined(WIN32)
  glLoadTransposeMatrixd =
    (PFNGLLOADTRANSPOSEMATRIXDPROC)wglGetProcAddress("glLoadTransposeMatrixd");
#endif
}

/* ȥåܡѴؿ */
#include "trackball.h"

/* Ȣؿ */
#include "box.h"

/*
** 
*/
static void scene(void)
{
  static const GLfloat color[] = { 1.0, 1.0, 1.0, 1.0 };  /*  () */
  
  /*  */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color);
  
  /* оݤtexname[0] Υƥڤؤ*/
  glBindTexture(GL_TEXTURE_CUBE_MAP, texname[0]);
  
  /* ƥĶ */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  
  /* 塼֥ޥåԥ󥰤ͭˤ */
  glEnable(GL_TEXTURE_CUBE_MAP);
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);
  
  /* ƥѴ˥ȥåܡ뼰βžä */
  glMatrixMode(GL_TEXTURE);
  glLoadTransposeMatrixd(trackballRotation());
  glMatrixMode(GL_MODELVIEW);
  
  /* 꾯˥ƥݥåȤ */
  glPushMatrix();
  glTranslated(0.0, 0.0, -5.0);
  glutSolidTeapot(1.0);
  glPopMatrix();
  
  /* ƥѴ򸵤᤹ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);
  
  /* 塼֥ޥåԥ󥰤 */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  glDisable(GL_TEXTURE_CUBE_MAP);
  
  /* оݤ̵̾ƥ᤹ */
  glBindTexture(GL_TEXTURE_2D, 0);
  
  /* ƥĶ */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  
  /* ƥޥåԥ󥰳 */
  glEnable(GL_TEXTURE_2D);
  
  /* ȥåܡˤž */
  glMultMatrixd(trackballRotation());
  
  /* Ȣ */
  box(50.0, 50.0, 50.0);
  
  /* ƥޥåԥ󥰽λ */
  glDisable(GL_TEXTURE_2D);
}


/****************************
** GLUT ΥХåؿ **
****************************/

static void display(void)
{
  /* ̥ꥢ */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* ǥӥ塼Ѵ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* ΰ֤ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
#if 0
  /* ΰưʪΤ˰ư*/
  glTranslated(0.0, 0.0, -5.0);
#endif
  
  /*  */
  scene();
  
  /* ֥Хåե */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* ȥåܡ뤹ϰ */
  trackballRegion(w, h);
  
  /* ɥΤӥ塼ݡȤˤ */
  glViewport(0, 0, w, h);
  
  /* ƩѴλ */
  glMatrixMode(GL_PROJECTION);
  
  /* ƩѴν */
  glLoadIdentity();
  gluPerspective(60.0, (double)w / (double)h, 1.0, 100.0);
}

static void idle(void)
{
  /* ̤ؤ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* ȥåܡ볫 */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* ȥåܡ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* ȥåܡư */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q 򥿥פ齪λ */
    exit(0);
  default:
    break;
  }
}

/*
** ᥤץ
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
